#include <stdio.h>
#include <windows.h>
#include <time.h>

int main(int argc,char**argv)
 {
 FILE *datei;
 HANDLE If;
 DCB dcb;
 COMMTIMEOUTS to;
 char st1[500],st2[100],ch,ch1,*cp1,Parity,Datenbits,Stopbits;
 long int a,b,c,Baud,Inhibit=0,StartOfData=0;
 
 if(argc<4)
  {
  printf("Benutzung: sercapt <Schnittstelle> <Parameter> <Zieldatei>\n"
         "Beispiel: sercapt com1 9600,8,n,1 test.csv          oder\n"
         "          sercapt \\\\.\\com12 9600,8,n,1 test.csv\n"
         "Weiter mit der Entertaste..");
  getch();
  return -1;
  }
 if(argc>4) sscanf(argv[4],"%d",&StartOfData);
 printf("StartOfData=%d\n",StartOfData);
 /* COM-Schnittstelle ffnen */
 If=CreateFile(argv[1],GENERIC_READ,0,NULL,OPEN_EXISTING,
               FILE_ATTRIBUTE_NORMAL,NULL);
 if(If==INVALID_HANDLE_VALUE)
  {
  printf("Schnittstelle %s konnte nicht geoeffnet werden!\n"
         "Weiter mit der Entertaste..",argv[1]);  
  getch();
  return -1;
  }
 sscanf(argv[2],"%d,%c,%c,%c",&Baud,&Datenbits,&Parity,&Stopbits);
 ZeroMemory(&dcb,sizeof(dcb));
 dcb.DCBlength=sizeof(dcb);
 dcb.BaudRate=Baud;
 dcb.ByteSize=Datenbits-'0';
 switch(Parity)
  {
  case 'e':
   {
   dcb.Parity=EVENPARITY;
   dcb.fParity=TRUE;
   break;
   }
  case 'o':
   {
   dcb.Parity=ODDPARITY;
   dcb.fParity=TRUE;
   break;
   }
  default:
   {
   dcb.Parity=NOPARITY;
   dcb.fParity=FALSE;   
   }
  }
 switch(Stopbits)
  {
  case '2':
   {
   dcb.StopBits=TWOSTOPBITS;  
   }
  default:
   {
   dcb.StopBits=ONESTOPBIT;
   }
  }
 SetCommState(If,&dcb);
 to.ReadIntervalTimeout=MAXDWORD;
 to.ReadTotalTimeoutMultiplier=100000;
 to.ReadTotalTimeoutConstant=100000;
 to.WriteTotalTimeoutMultiplier=1;
 to.WriteTotalTimeoutConstant=1;
 SetCommTimeouts(If,&to);

 /* Gibt es die Zieldatei schon? Wenn nicht, Kopfdatei kopieren */
 datei=fopen(argv[3],"r");
 if(datei) fclose(datei);
 else
  {
  strcpy(st1,argv[0]); /*Programmdatei selbst*/
  cp1=strrchr(st1,'\\');
  if(cp1) 
   {
   cp1++;
   *cp1=0;
   }
  else st1[0]=0;
  strcat(st1,"kopf.txt");
  datei=fopen(st1,"r");
  if(!datei)
   {
   printf("Kopfdatei %s nicht gefunden,"
          " weiter mit Entertaste...",st1);
   getch();
   return -1;
   }
  fscanf(datei,"%s",st1);
  fclose(datei);
  datei=fopen(argv[3],"w");
  fprintf(datei,"%s\n",st1);
  fclose(datei);
  printf("Zieldatei neu angelegt!\n");
  }
 cp1=0;
 strcpy(st1,"");
 while(1)
  {
  c=0;
  ReadFile(If,st2,1,&c,NULL);
  if(c)
   {
   ch=st2[0];
   if((ch=='\n')||(ch=='\r')) /* Beginn neue Zeile */
    {
    if(strlen(st1))
     {
     time_t Zeit;
     struct tm *t;
     Zeit=time(0);
     t=localtime(&Zeit);
     sprintf(st2,"%02d.%02d.%04d;%02d:%02d:%02d;",t->tm_mday,t->tm_mon+1,t->tm_year+1900,
                                                 t->tm_hour,t->tm_min,t->tm_sec);
     
     *cp1=0;
     datei=fopen(argv[3],"a");
     if(!datei)
      {
      printf("Datei %s kann nicht beschrieben werden!\n"
             "weiter mit der Entertaste...");
      getch();
      return -1;
      }
     fprintf(datei,"%s%s\n",st2,st1);
     printf("\n");
     fclose(datei);
     strcpy(st1,"");
     }
    cp1=st1;
    if(StartOfData) Inhibit=1;	/*Datenbeschriftung berspringen, bis Startzeichen*/
    }
   else		/* Sonstige Zeichen */
    {
     if(cp1)
      {
      if(Inhibit)
       {
       if(ch==StartOfData) Inhibit=0;
       }
      else
       {
       if(ch=='\t') ch=';';
       if(ch==' ') ch=';';
       putchar(ch);
       *cp1=ch;
       if((ch==';')&&(StartOfData)) Inhibit=1;
       cp1++;
       }
      }
    }
   }
  }
 /* Dieser Code wird eigentlich nie erreicht */
 return 0;
 }
